/**********************************************************************
 * Copyright (C) 20014-2015 by Vidisolve (Pty) Ltd.                   *
 * All Rights Reserved.                                               *
 *                                                                    *
 *  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY    *
 *   KIND, either express or implied.                                 *
 *                                                                    *
 *  Contributors:                                                     *
 *                                                                    *
 **********************************************************************/
/*------------------------------------------------------------------------
    File        : siRunProcess.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Tue Jun 09 19:50:48 CAT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

BLOCK-LEVEL ON ERROR UNDO, THROW.

/* ***************************  Main Block  *************************** */
DEFINE INPUT  PARAMETER cProcedure       AS CHARACTER NO-UNDO.
DEFINE INPUT  PARAMETER cAction          AS CHARACTER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER cData      AS CHARACTER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER TABLE-HANDLE hDataset.
DEFINE OUTPUT PARAMETER cMessage         AS CHARACTER NO-UNDO.

DEFINE VARIABLE hCP AS HANDLE NO-UNDO.

/* The following line belongs in the AppServer Startup routine, not here. */
SECURITY-POLICY:LOAD-DOMAINS("security").

/* Get the user's identity */
hCP = SESSION:CURRENT-REQUEST-INFO:GetClientPrincipal().

/* If we come from the CustomSSO, we can validate the seal as follows... */
IF hCP:DOMAIN-NAME = "AppDomain"
THEN hCP:VALIDATE-SEAL ("DomainSecretKey").


/* Set the session wide identity - this will also set the identity for all
   databases that was not set explicitly before.
   The seal will be validated at this point, or the system will attempt to
   log the user in if the CLIENT-PRINCIPAL's LOGIN-STATE = "INITIAL"      */
SECURITY-POLICY:SET-CLIENT (hCP).

RUN VALUE(cProcedure) (INPUT cAction, INPUT-OUTPUT TABLE-HANDLE hDataset, INPUT-OUTPUT cData, OUTPUT cMessage).
