/**********************************************************************
 * Copyright (C) 20014-2015 by Vidisolve (Pty) Ltd.                   *
 * All Rights Reserved.                                               *
 *                                                                    *
 *  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY    *
 *   KIND, either express or implied.                                 *
 *                                                                    *
 *  Contributors:                                                     *
 *                                                                    *
 **********************************************************************/
/*------------------------------------------------------------------------
    File        : pDomainCallback.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Tue Jun 09 12:53:04 CAT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

BLOCK-LEVEL ON ERROR UNDO, THROW.

USING Progress.Security.*.

/* ********************  Preprocessor Definitions  ******************** */

/* ************************  Function Prototypes ********************** */



/* ***************************  Main Block  *************************** */

/* ************************  Internal Procedures ********************** */
PROCEDURE AuthenticateUser:
    DEFINE INPUT  PARAMETER phdlCP            AS HANDLE            NO-UNDO.
    DEFINE INPUT  PARAMETER pchrSystemOptions AS CHARACTER EXTENT  NO-UNDO.
    DEFINE OUTPUT PARAMETER pintPAMStatus     AS INTEGER INITIAL ? NO-UNDO.
    DEFINE OUTPUT PARAMETER chrErrorMsg       AS CHARACTER         NO-UNDO.


    DEFINE VARIABLE lSuccess    AS LOGICAL NO-UNDO.
    DEFINE VARIABLE cRoles      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRoleNames  AS CHARACTER NO-UNDO.

    /* Local variables */
    DEFINE VARIABLE logCheckStop    AS LOGICAL NO-UNDO.

    DO ON STOP UNDO, LEAVE
       ON QUIT UNDO, LEAVE :

        ASSIGN pintPAMStatus = ?
               logCheckStop  = TRUE.

        /* Perform validation */
        RUN procLogin (INPUT  phdlCP:USER-ID,
                       phdlCP:PRIMARY-PASSPHRASE,
                       OUTPUT lSuccess,
                       OUTPUT cRoles,
                       OUTPUT cRoleNames).

        IF lSuccess = TRUE
        THEN pintPAMStatus = PAMStatus:Success.
        ELSE pintPAMStatus = PAMStatus:Custom.

        phdlCP:ROLES = cRoles.
        phdlCP:SET-PROPERTY("RoleNames",cRoleNames).
        logCheckStop = FALSE.
    END.

    IF logCheckStop THEN
        ASSIGN pintPAMStatus = PAMStatus:Custom
               chrErrorMsg   = "STOP condition found!".

END PROCEDURE.

PROCEDURE AfterSetIdentity:   /* Optional */
    DEFINE INPUT  PARAMETER phdlCP            AS HANDLE            NO-UNDO.
    DEFINE INPUT  PARAMETER pchrSystemOptions AS CHARACTER EXTENT  NO-UNDO.

    /* Set Global shared variables */
END.

PROCEDURE procLogin PRIVATE:
     DEFINE INPUT  PARAMETER pLoginID AS CHARACTER NO-UNDO.
     DEFINE INPUT  PARAMETER pPasswd  AS CHARACTER NO-UNDO.
     DEFINE OUTPUT PARAMETER pSuccess   AS LOGICAL   NO-UNDO.
     DEFINE OUTPUT PARAMETER pRoles     AS CHARACTER NO-UNDO.
     DEFINE OUTPUT PARAMETER pRolesDesc AS CHARACTER NO-UNDO.

     FIND secUser NO-LOCK
        WHERE secUser.loginID = pLoginID
          AND secUser.passwd  = pPasswd
        NO-ERROR.

    IF AVAILABLE secUser
    THEN DO:
        FOR EACH userRole OF secUser, FIRST role OF userRole:
            pRoles = pRoles + "," + role.roleKey.
            pRolesDesc = pRolesDesc + "," + role.Description.
        END.
        ASSIGN
            pSuccess = TRUE
            pRoles     = SUBSTRING(pRoles,2).
            pRolesDesc = SUBSTRING(pRolesDesc,2)
            .
    END.
    RETURN.
END PROCEDURE.

/* ************************  Function Implementations ***************** */

